/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
de.ggbs.cs2c.mc.gMessengerBundle = null;

de.ggbs.cs2c.mc.addElems= function() {
  var m_nc=document.getElementById('nocopy://');
    m_nc.setAttribute('accesskey',de.ggbs.cs2c.mc.CS2C.ak_nc);
  var m_d=document.getElementById('default://');
    if (m_d) m_d.setAttribute('accesskey',de.ggbs.cs2c.mc.CS2C.ak_d);
  var m_s=document.getElementById('sent://');
    if (m_s) m_s.setAttribute('accesskey',de.ggbs.cs2c.mc.CS2C.ak_s);

  var defelem=document.getElementById('lastused://');
  if (defelem) {
    defelem.hidden = true;
    //add menu items to pre-send selector
    var ak_num=de.ggbs.cs2c.mc.CS2C.numberedAccessKeys;
    var menu=document.getElementById('de-ggbs-cs2c-copyMenuPopup');
    if (de.ggbs.cs2c.mc.CS2C.maxLength>1) {
      if (ak_num)
        defelem.setAttribute('accesskey',de.ggbs.cs2c.mc.CS2C.maxLength);
      else
        defelem.removeAttribute('accesskey');
    }
    for (var i=1; i<de.ggbs.cs2c.mc.CS2C.maxLength; i++) {
      var newelem=defelem.cloneNode(true);
      newelem.hidden = true;
      newelem.id=newelem.id+i;
      if (ak_num) newelem.setAttribute('accesskey',i);
      else if (i==1) newelem.setAttribute('accesskey',de.ggbs.cs2c.mc.CS2C.ak_lu);
      menu.insertBefore(newelem, defelem);
    }
    defelem.id=defelem.id+0;
  }
}

de.ggbs.cs2c.mc.fillElems = function(w) {
  var elem=document.getElementById('de-ggbs-cs2c-sep');
  if (de.ggbs.cs2c.mc.CS2C.maxLength<=1)
    elem.hidden=true;
  else
    elem.hidden=de.ggbs.cs2c.mc.CS2C.length==0;
  if (!w) w=window;

    // TODO: eventuell das element weglassen das mit dem aktuellen default bereinstimmt
  for (var i=0; i<de.ggbs.cs2c.mc.CS2C.maxLength; i++) {
    elem=elem.nextSibling;
    if (i<de.ggbs.cs2c.mc.CS2C.length) {
      var uri=de.ggbs.cs2c.mc.CS2C.get_URI(i);
      var folder;
      if (typeof MailUtils=='object') { //since TB3b3
        folder=MailUtils.getFolderForURI(uri, true);
      } else {  //TB2-TB3b2, Eudora
        folder=w.GetMsgFolderFromUri(uri, true);
      }
        //"imap://ggbs@mailhost.iwf.ing.tu-bs.de/INBOX/xdraft/ydraft"
        // nicht existente teile am ende funktionieren trotzdem
        //  (wird der folder angelegt? Nein! Wird irgendwohin gespeichert)
        // erst wenn host nicht korrekt, ist folder null
      try {
        // make the 'folder in server' text
        if (!de.ggbs.cs2c.mc.gMessengerBundle)
          de.ggbs.cs2c.mc.gMessengerBundle = w.document.getElementById("bundle_messenger");
        var label=de.ggbs.cs2c.mc.gMessengerBundle.getFormattedString("verboseFolderFormat",
                    [folder.name, folder.server.prettyName]);

        elem.hidden = false;
        elem.label  = label;
        elem.id     = uri;
      } catch(e) {
        de.ggbs.cs2c.mc.CS2C.del_URI(i);
        var console = Components.classes["@mozilla.org/consoleservice;1"]
                         .getService(Components.interfaces.nsIConsoleService);
        var scriptError = Components.classes["@mozilla.org/scripterror;1"]
                         .createInstance(Components.interfaces.nsIScriptError);
        scriptError.init('CopySent2Current: fillElems: folder for URI '+uri+' not found\n',
                /*aSourceName*/null, /*aSourceLine*/null, /*aLineNumber*/null,
                       /*aColumnNumber*/null, /*nsIScriptError.warningFlag*/1, '');
        console.logMessage(scriptError);
      }
    } else {
      elem.hidden = true;
    }
  }
}
